diff -cprN postgresql-jdbc-8.3-603.src-orig/doc/pgjdbc.xml postgresql-jdbc-8.3-603.src/doc/pgjdbc.xml
*** postgresql-jdbc-8.3-603.src-orig/doc/pgjdbc.xml	2008-01-08 15:56:26.000000000 +0900
--- postgresql-jdbc-8.3-603.src/doc/pgjdbc.xml	2008-02-11 16:56:58.000000000 +0900
*************** Connection conn = DriverManager.getConne
*** 592,597 ****
--- 592,607 ----
        </varlistentry>
  
        <varlistentry>
+        <term><varname>tcpkeepalive</varname> = <type>boolean</type></term>
+        <listitem>
+         <para>
+ 	 Enable or disable TCP keep-alive probe. The default is
+         <literal>false</literal>.
+ 	</para>
+        </listitem>
+       </varlistentry>
+ 
+       <varlistentry>
         <term><varname>stringtype</varname> = <type>String</type></term>
         <listitem>
          <para>
diff -cprN postgresql-jdbc-8.3-603.src-orig/org/postgresql/Driver.java.in postgresql-jdbc-8.3-603.src/org/postgresql/Driver.java.in
*** postgresql-jdbc-8.3-603.src-orig/org/postgresql/Driver.java.in	2008-01-08 15:56:26.000000000 +0900
--- postgresql-jdbc-8.3-603.src/org/postgresql/Driver.java.in	2008-02-11 17:06:16.000000000 +0900
*************** public class Driver implements java.sql.
*** 442,447 ****
--- 442,449 ----
                    new String[] { "7.1", "7.2", "7.3", "7.4", "8.0", "8.1", "8.2" } },
                  { "loginTimeout", Boolean.FALSE,
                    "The login timeout, in seconds; 0 means no timeout beyond the normal TCP connection timout." },
+                 { "tcpkeepalive", Boolean.FALSE,
+                   "Enable or disable TCP keep-alive probe." },
                  { "stringtype", Boolean.FALSE,
                    "The type to bind String parameters as (usually 'varchar'; 'unspecified' allows implicit casting to other types)",
                    new String[] { "varchar", "unspecified" } },
diff -cprN postgresql-jdbc-8.3-603.src-orig/org/postgresql/core/v2/ConnectionFactoryImpl.java postgresql-jdbc-8.3-603.src/org/postgresql/core/v2/ConnectionFactoryImpl.java
*** postgresql-jdbc-8.3-603.src-orig/org/postgresql/core/v2/ConnectionFactoryImpl.java	2008-01-08 15:56:27.000000000 +0900
--- postgresql-jdbc-8.3-603.src/org/postgresql/core/v2/ConnectionFactoryImpl.java	2008-02-11 17:10:04.000000000 +0900
*************** public class ConnectionFactoryImpl exten
*** 46,51 ****
--- 46,54 ----
          boolean requireSSL = (info.getProperty("ssl") != null);
          boolean trySSL = requireSSL; // XXX temporary until we revisit the ssl property values
  
+ 	//  - the TCP keep alive setting
+ 	boolean requireTCPKeepAlive = (Boolean.valueOf(info.getProperty("tcpkepealive")).booleanValue());
+ 
          if (logger.logDebug())
              logger.debug("Trying to establish a protocol version 2 connection to " + host + ":" + port);
  
*************** public class ConnectionFactoryImpl exten
*** 69,74 ****
--- 72,80 ----
              if (trySSL)
                  newStream = enableSSL(newStream, requireSSL, info, logger);
  
+             // Enable TCP keep-alive probe if required.
+ 	    newStream.getSocket().setKeepAlive(requireTCPKeepAlive);
+ 
              // Construct and send a startup packet.
              sendStartupPacket(newStream, user, database, logger);
  
diff -cprN postgresql-jdbc-8.3-603.src-orig/org/postgresql/core/v3/ConnectionFactoryImpl.java postgresql-jdbc-8.3-603.src/org/postgresql/core/v3/ConnectionFactoryImpl.java
*** postgresql-jdbc-8.3-603.src-orig/org/postgresql/core/v3/ConnectionFactoryImpl.java	2008-01-08 15:56:27.000000000 +0900
--- postgresql-jdbc-8.3-603.src/org/postgresql/core/v3/ConnectionFactoryImpl.java	2008-02-11 17:09:58.000000000 +0900
*************** public class ConnectionFactoryImpl exten
*** 50,55 ****
--- 50,58 ----
          boolean requireSSL = (info.getProperty("ssl") != null);
          boolean trySSL = requireSSL; // XXX temporary until we revisit the ssl property values
  
+         //  - the TCP keep alive setting
+         boolean requireTCPKeepAlive = (Boolean.valueOf(info.getProperty("tcpkeepalive")).booleanValue());
+ 
          // NOTE: To simplify this code, it is assumed that if we are
          // using the V3 protocol, then the database is at least 7.4.  That
          // eliminates the need to check database versions and maintain
*************** public class ConnectionFactoryImpl exten
*** 80,85 ****
--- 83,91 ----
              if (trySSL)
                  newStream = enableSSL(newStream, requireSSL, info, logger);
  
+ 	    // Enable TCP keep-alive probe if required.
+ 	    newStream.getSocket().setKeepAlive(requireTCPKeepAlive);
+ 
              // Construct and send a startup packet.
              String[][] params = {
                                      { "user", user },
